// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "VNEvent.hpp"

namespace Dawn {
  class VNIfEvent : public VNEvent {
    public:
      std::string key;
      std::string value;
      VNEvent *ifTrue = nullptr;

      VNEvent * getNextEvent() override {
        if(this->manager.getFlag(key) == value) {
          return ifTrue;
        }
        return VNEvent::getNextEvent();
      }

    protected:
      void onStart() override {
        this->next();
      }
  }
}